jQuery(function($){
	
	const TIPO_MODO_0 = 0; // para informes sociales
	const TIPO_MODO_1 = 1; // para resto de informes
	let isNewInfSocial = false;
	let MODOCONSULTA = false;
	let MODOEDICION = false
	
	initRupI18nPromise.then(function () {
		initFilter();
		initTable();
		initDialog();
		mostrarBotones();
				
		Ad74aUtils.hacerPlegable();
		Ad74aUtils.soloNumericos();
		
		$("#bandejainformes_filter_form").rup_validate({
		    liveCheckingErrors: false,
		    showFieldErrorAsDefault: true,
		    showErrorsInFeedback: true,
		    showFieldErrorsInFeedback: true,
		    rules:{
		    	"fInicio16":{date:true},
		    	"fFin16":{date:true},
		    	//"fEnvioAdmon16":{checkDates:true},
		    }
		});
		
		$("#bandejainformes_filter_form [ruptype='date']").blur(function(elem) { 

			if(!$(elem.target).valid()){
                $(elem.target).val('')
            }

		})
		
	});	
	
	const initFilter = () => {
		$.rup_date({
			yearRange: 'c-100:c+100',
	        from: "fecInicio_informes_filter_table",
	        to: "fecFin_informes_filter_table",
	        mask: 'dd/mm/yyyy'
	    });
		
		$('#fecEnvioAdmin_informes_filter_table').rup_date({
			yearRange: 'c-100:c+100',
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss'
		});
		
		$("#solicitante_informes_filter_table").rup_combo({
			rowStriping: true,
			ordered: true,
			blank: '',
			customClasses: ['select-material'],
			loadFromSelect:true,
		});
		
		$("#unidadBase16_informes_dialog_table").rup_combo({
			source: $.rup.CTX_PATH + 'combo/unidadesBaseInformes',
			sourceParam: {label: "desc", value:"idUnidadBase92"},
			loadFromSelect:false,
			width: 'auto',
	        ordered: false,
			rowStriping: true,
			blank:'',
			customClasses: ['select-material'],
			height: 'auto',
			
			onLoadSuccess:function(){
//				console.log(MODOCONSULTA);
//				console.log(MODOEDICION);
				if(MODOCONSULTA){
					$("#unidadBase16_informes_dialog_table").rup_combo("disable");
				}else{
					$("#unidadBase16_informes_dialog_table").rup_combo("enable");
				}
				
			}
		});
		
		$("#unidadBase16_infInt_dialog_table").rup_combo({
			source: $.rup.CTX_PATH + 'combo/unidadesBaseInformes',
			sourceParam: {label: "desc", value:"idUnidadBase92"},
			loadFromSelect:false,
			width: 'auto',
	        ordered: false,
			rowStriping: true,
			blank:'',
			customClasses: ['select-material'],
			height: 'auto',
			onLoadSuccess:function(){
				if(MODOCONSULTA){
					$("#unidadBase16_infInt_dialog_table").rup_combo("disable");
				}else{
					$("#unidadBase16_infInt_dialog_table").rup_combo("enable");
				}
				
			}
		});
		
		$("#estado_informes_filter_table").rup_combo({
			parent: ["tipoInforme_informes_filter_table"],
			source: $.rup.CTX_PATH +"combo/estadosInforme",
			sourceParam: {label: "label", value:"value"},
			rowStriping: true,
			ordered: false,
			blank: '',
			customClasses: ['select-material'],
			//loadFromSelect:true,
			width: 'auto',
//			disabled: true
		});
		
		//$('#estado_informes_filter_table').rup_combo("disable");
		

		$("#tipoInforme_informes_filter_table").rup_combo({
			rowStriping: true,
			ordered: false,
			blank: '',
			customClasses: ['select-material'],
			loadFromSelect:true,
			width: 'auto',
			change: () => {
				/*if($('#tipoInforme_informes_filter_table').val() != ''){
					$('#estado_informes_filter_table').rup_combo("enable");
					//$('#estado_informes_filter_table').rup_combo("refresh");
				}else {
					$('#estado_informes_filter_table').rup_combo("setRupValue", '');
					$('#estado_informes_filter_table').rup_combo("disable");
				}*/
			}
		});
		
		
		
		
		$('#mostrarOcultos_informes_filter_table').prop("checked",true);

	}
	
	const initTable = () => {
		
		const getColumnsModel = function () {
			const getColumnModel = function (name, index, editable, hidden, orderable) {
				return {
					name: name,
					index: index,
					editable: editable,
					hidden: hidden,
					orderable: orderable
					
				}
			};
			let columnsModel = [];
			columnsModel.push(getColumnModel("idInforme16", "idInforme16", false, false, false));
			columnsModel.push(getColumnModel("documentosInforme.idDocInforme17", "documentosInforme.idDocInforme17", false, true, false));
			columnsModel.push(getColumnModel("solicitantes.identificador01", "solicitantes.identificador01", false, false, true));
			columnsModel.push(getColumnModel("nombreApellidosBeneficiario", "nombreApellidosBeneficiario", false, false));
			columnsModel.push(getColumnModel("expedientes.numExpediente00", "expedientes.numExpediente00", false, false));
			columnsModel.push(getColumnModel("direccion", "direccion", false, false));
			columnsModel.push(getColumnModel("tipoInformeDesc", "tipoInformeDesc", false, false));			
			columnsModel.push(getColumnModel("usuario.nombreCompleto", "usuario.nombreCompleto", false, false));
			columnsModel.push(getColumnModel("estadoDesc", "estadoDesc", false, false));
			columnsModel.push(getColumnModel("fInicio16", "fInicio16", false, false));
			//columnsModel.push(getColumnModel("fFin16", "fFin16", false, false));
			columnsModel.push(getColumnModel("fEnvioAdmon16", "fEnvioAdmon16", false, false));
			columnsModel.push(getColumnModel("documento", "documento", false, false, false));
			columnsModel.push(getColumnModel("origen16", "origen16", false, true));
			columnsModel.push(getColumnModel("oculto16", "oculto16", false, true));
			columnsModel.push(getColumnModel("usuAlta16", "usuAlta16", false, true));
			columnsModel.push(getColumnModel("usuModif16", "usuModif16", false, true));
			columnsModel.push(getColumnModel("fAlta16", "fAlta16", false, true));
			columnsModel.push(getColumnModel("fModif16", "fModif16", false, true));
			//columnsModel.push(getColumnModel("numdocumentos", "numdocumentos", false, false, false));
			return columnsModel;
		};
		
		const getColumnsDefs = function () {
			return [
				{ 
					"targets": 0,
					"className": "icons-column",
					"width": "17px",
					"render": function(data, type, row, settings){
						let iconUrgencia = "";
	    		    	if(row.urgente16 == '1'){							
	    		    		iconUrgencia = `
								<span class="mdi mdi-clock-fast naranja sol_urgente_icon " 
									style="float: right;">
								</span>
							`;				   
	   	    		 	}
						
						let iconOculto = "";
	    		    	if(row.oculto16 == '1'){							
	    		    		iconOculto = `
								<span class="mdi mdi-eye-off" 
									style="float:right">
								</span>
							`;				   
	   	    		 	} 
	    		    	
	    		    	let iconObs = "";
	    		    	let textObs = "";
	    		    	if(row.observaciones16 != null && row.observaciones16 != '') {
	    		    		textObs += row.observaciones16;
	    		    	} 
	    		    	if(row.informeSocial.observaciones02 != null && row.informeSocial.observaciones02 != ''){
	    		    		textObs += textObs==""?"":"<br/>";
	    		    		textObs += "<br/><strong>Observaciones Trabajador/a Social</strong><br/>"+row.informeSocial.observaciones02;
	    		    	}
//	    		    	if(row.informeSocial.observacionesPs02 != null && row.informeSocial.observacionesPs02 != ''){
//	    		    		textObs += textObs==""?"":"<br/>";
//	    		    		textObs += "<br/><strong>Observaciones del prestatario</strong><br/>"+row.informeSocial.observacionesPs02;
//	    		    	}	    		    	
	    		    	
	    		    	if(textObs != "") {
	    		    		iconObs += `<span class="mdi mdi-note-multiple-outline obs-icon verde" 
							 style="float:right" obs='${textObs}'></span>`;
	    		    	}
	    		    	
						return iconUrgencia +iconOculto + iconObs;									
					}
				},
				{
					"targets": 2,
					"render": function(data, type, row, settings){
						if ( row.solicitantes.idSolicitante01 != null) {						 
							const url = '../solicitantes/detail/' + row.solicitantes.idSolicitante01;
							return `<a href='javascript:window.open("${url}", "_blank");'>${row.solicitantes.identificador01}</a>`;						
						}						
						return row.solicitantes.identificador01 != null?row.solicitantes.identificador01:"";
					}
				},
				{
					"targets": 4,
					"render": function(data, type, row, settings){
						if ( row.expedientes.idExpediente00 != null && !isSSB &&  !isPS) {						 
							const url = '../expedientes/detail/' + row.expedientes.idExpediente00;
							return `<a href='javascript:window.open("${url}", "_blank");'>${row.expedientes.numExpediente00}</a>`;						
						}						
						return row.expedientes.numExpediente00 != null?row.expedientes.numExpediente00:"";
					}
				},
				{
					"targets": 5,
					"width":'15%',
					"render": function(data, type, row, settings){
						return row.direcciones.direccionCompleta;
						
					}
					
				},
				{
					"targets": 7,
					"render": function(data, type, row, settings){
						if ( row.usuario != null && row.usuario.nombreCompleto != null ) {						 
							return row.usuario.nombreCompleto;					
						}						
						return "";
					}
				},
				{
					"targets": 8,
					"render": function(data, type, row, settings){
						if(isSSB && row.tipoInforme16 == TIPOINFORMEINT && row.estado16 >= SOLICITADO_PROVEEDOR) {
							return EN_TRAMITACION_DESC.toUpperCase();
						}
						if(data != undefined && data != null){
							return data.toUpperCase();	
						}else{
							return '';
						}
						
					}
				},
				{
					"targets": 11,
					"render": function ( data, type, row, meta ) {
						if(row.documentosInforme != null && row.documentosInforme.idDocInforme17 != null && row.documentosInforme.oid17 != null){							
							if((isSSB && row.tipoInforme16 == TIPOIINFORMESOCIAL) || (isDSS) || (isPS && row.tipoInforme16 == TIPOINFORMEINT)) {
								return `<a href='javascript:$.downloadDocument("${row.documentosInforme.oid17}", "${row.documentosInforme.nombreDoc17}");'>
									<i class='mdi mdi-download'></i>
								</a>`;
							}				
						}
						return "";
					}
				}
			];
		};
		
		
		$("#bandejainformes").rup_table({
			colReorder: {
			 fixedColumnsLeft: 1
			}
			,colModel: getColumnsModel()
			,columnDefs : getColumnsDefs()
			,primaryKey: "idInforme16"
			,filter:{
	  	  		id:"bandejainformes_filter_form",
	  	  		filterToolbar:"bandejainformes_filter_toolbar",
	  	  		collapsableLayerId:"bandejainformes_filter_fieldset",
	  	  		showHidden: true
	     	}
       		,select: {
           		activate: true
       		}
    		,seeker: {
    			activate: true
			}
    		,createTooltipBody: false
			,buttons: {
				activate: true,
				blackListButtons: ['addButton', 'cloneButton', 'copyButton','deleteButton','pdfButton', 'odsButton', 'csvButton','editButton'],
				myButtons:misBotones
			}
			,
			columnOrderArrows: {
			    showOnlyActive: false,
			    display: 'inline'
			},
			"rowCallback": function( row, data, index ) {
				if ( data.urgente16 >= 1){
					$(row).addClass('orange_row');
				}
			},
			drawCallback: function(ctx) {
				$(".obs-icon").rup_tooltip({
					content: {
						text: function(event, api) {
							let text = $(this).attr('obs');
							text = text.replaceAll('\n', '<br/>');
							return text;
						}
					}, 
					position: {
						my: 'bottom left',  // Position my top left...
						at: 'top left', // at the bottom right of...
					},   
					style: { 
						classes: 'qtip-green qtip-large' 
					}
				});
				
				$(".sol_urgente_icon").rup_tooltip({
					content: {
						text: $.rup.i18n.app.tooltip.urgente
					}, 
					position: {
						my: 'bottom left',  // Position my top left...
						at: 'top left', // at the bottom right of...
					},   
					style: { 
						classes: 'qtip-orange' 
					}
				});
				
				//Evento doble click sobreescrito
				const rowsBody = $(ctx.nTBody);
				rowsBody.off('dblclick', 'tr');
				rowsBody.on('dblclick', 'tr', function (e) {
					//console.log(ctx.json.rows[this._DT_RowIndex]);
					const row = ctx.json.rows[this._DT_RowIndex];
					
					let textObs = "";
    		    	if(row.observaciones16 != null && row.observaciones16 != '') {
    		    		textObs += row.observaciones16;
    		    	} 
    		    	if(row.informeSocial.observaciones02 != null && row.informeSocial.observaciones02 != ''){
    		    		textObs += textObs==""?"":"<br/>";
    		    		textObs += `<br/><strong>Observaciones Trabajador/a Social</strong><br/>${row.informeSocial.observaciones02}`;
    		    	}
//    		    	if(row.informeSocial.observacionesPs02 != null && row.informeSocial.observacionesPs02 != ''){
//    		    		textObs += textObs==""?"":"<br/>";
//    		    		textObs += `<br/><strong>Observaciones del prestador</strong><br/>${row.informeSocial.observacionesPs02}`;
//    		    	}
    		    	
    		    	if(textObs != "") {
    		    		const estado = (isSSB && row.tipoInforme16 == TIPOINFORMEINT && row.estado16 >= SOLICITADO_PROVEEDOR)?EN_TRAMITACION_DESC.toUpperCase():row.estadoDesc.toUpperCase();
    		    		Ad74aUtils.openConfirmDialog(
							'dialogConfirm', 
							`${$.rup.i18n.app.dialog.title.observaciones}: 
								${row.tipoInformeDesc} (${estado}) / ${row.dninombreApellidosBeneficiario}													
							`, 
							textObs.replaceAll('\n', '<br/>'),  
							[
					        	{
					                text: $.rup.i18n.app.botonera.cerrar,
					                click: function () { 
					                    $('#dialogConfirm').rup_dialog('close'); 
					                },
					                btnType: $.rup.dialog.LINK
					                
					            }
					        ],
					        'custom_mid_dialog rup-message rup-message-ok overflow-y-auto'
						);
    		    	}
    		    	
	            });
			}
			,order: [[9, "asc"]],
			"initComplete": function(settings, json) {
				console.log("initComplete");
				const properties = {
					"init": "true",
					"click": true,
					"callback": () => {
						$("#bandejainformes").rup_table("reload");
					}, // función a ejecutar 
					"style": {}, // estilos para la barra de progreso
					"refreshInterval": "60" //segundos
				}
				//Ad74aUtils.timer("#actualizarListado", properties);				
			}
		});		
	}
	 
	const misBotones=[];
	
	const FN_EliminarDisplay = {};
	FN_EliminarDisplay.test  = function(){
		const selectedRows  = $("#bandejainformes").rup_table("getSelectedRows");	
		// 1 seleccionado y no tiene error en el expediente
		if ( selectedRows.length == undefined && selectedRows.tipoInforme16 == TIPOIINFORMESOCIAL) {
			return true;
		}
		return false;		
	};
	const btnEliminar = {
			text: function () {
				return  $.rup.i18n.app.informes.btnEliminar;
			},
			id: 'eliminarInformes', // Campo obligatorio si se quiere usar desde el contextMenu
			className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
			icon: "mdi-trash-can-outline",
			displayRegex: FN_EliminarDisplay,
			insideContextMenu: true, // Independientemente de este valor, sera 'false' si no tiene un id definido
			type: 'view',
			action : function(e, dt, node, config) {	
				Ad74aUtils.openConfirmDialog(
					'dialogConfirm', 
					$.rup.i18n.app.dialog.title.borrarInforme, 
					$.rup.i18n.app.dialog.label.borrarInforme,  
					[
			        	{
			                text: $.rup.i18n.app.botonera.cancelar,
			                click: function () { 
			                    $('#dialogConfirm').rup_dialog('close'); 
			                },
			                btnType: $.rup.dialog.LINK
			                
			            },
				        {
				            text: $.rup.i18n.app.botonera.aceptar,
				            id: "btnBloqueado",
				            click: function () { 
				            	$('#dialogConfirm').rup_dialog('close');
				            	
				            	$.rup_ajax({
				    	        	url: $.rup.CTX_PATH +"informes/eliminar/"+$('#bandejainformes').rup_table('getSelectedRows')['idInforme16'],
				    	            type: "POST",            
				    	            dataType: 'json',
				    	            contentType: 'application/json',
				    	            beforeSend: function(){
				    	            	Ad74aUtils.cerrarFeedbacks();
				    	            	Ad74aUtils.bloquearInterfaz();            	
				    				},
				    	            success: function (){
				                		$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.feedback.operacionOK, "ok");
				                		$('#bandejainformes').rup_table("reload");                    
				                  	},
				    				error: function (error) {
				    					Ad74aUtils.desBloquearInterfaz();
				    					$('#bandejaInformes_dialog_feedback').rup_feedback("option", "delay", null);
				    					$("#rup_feedback_bandejainformes").rup_feedback('set', error.responseJSON || error.responseText, "error");
				    				},
				                    complete: function() {
				                    	Ad74aUtils.desBloquearInterfaz();
				                    }
				    	        });	
				            	
				            	
				            },
				            class: 'btn-material btn-material-primary-high-emphasis'
				            
				        },
			        ],
			        'custom_small_dialog rup-message rup-message-confirm'
				);									
			}
        };
	
	const btnNuevoInformeSocial={
		text: function () {
			return  $.rup.i18n.app.informes.btnNuevoInformeSocial;
		},
		id: 'nuevoInformeSocialInformes', // Campo obligatorio si se quiere usar desde el contextMenu
		enabled : function() {
			return true;
		},
		displayRegex: /^\d+$/,
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
		icon: "mdi-file-plus",
		displayRegex: /^[0-9]*$/, // Se muestra siempre que sea un numero mayor a 0
		insideContextMenu: false, // Independientemente de este valor, sera 'false' si no tiene un id definido
		type: 'view',
		action : function(e, dt, node, config) {			
			openDialogDetalleInforme("add");				
		}
	};
	const btnSolicitarInformeIntervenciones={
		text: function () {
			return  $.rup.i18n.app.informes.btnSolicitarInformeIntervenciones;
		},
		id: 'solicitarInformeIntervencionesInformes', // Campo obligatorio si se quiere usar desde el contextMenu
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
		icon: "mdi-file-plus",
		displayRegex: /^\d+$/, // Se muestra siempre que sea un numero mayor a 0
		insideContextMenu: false, // Independientemente de este valor, sera 'false' si no tiene un id definido
		type: 'view',		
		action : function(e, dt, node, config) {
			MODOCONSULTA = false;
			$('#dialogSolicitarInformes').rup_dialog('open');
				
		}
	};
	
	const btnVerEditar={
		text: function () {
			return  $.rup.i18n.app.informes.btnVerEditar;
		},
		id: 'verEditarInformes', // Campo obligatorio si se quiere usar desde el contextMenu
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
		icon: "mdi-playlist-edit",
		displayRegex: /^[1-9][0-9]*$/, // Se muestra siempre que sea un numero mayor a 0
		insideContextMenu: true, // Independientemente de este valor, sera 'false' si no tiene un id definido
		type: 'view',
		action : function(e, dt, node, config) {					
			openDialogDetalleInforme("edit");							
		}
	};
	
	const btnOcultarMostrar = {
		text: function () {
			return $.rup.i18n.app.botonera.ocultarMostrar;
		},
		id: 'ocultarMostrar', // Campo obligatorio si se quiere usar desde el contextMenu
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
		icon: "mdi-eye-off-outline",
		displayRegex: /^[1-9][0-9]*$/, // Se muestra siempre que sea un numero mayor a 0
		insideContextMenu: true,
		//type: 'view',
		action: function (e, dt) {
			
			Ad74aUtils.openConfirmDialog(
				'dialogConfirm', 
				$.rup.i18n.app.dialog.title.mostrarOcultarInforme, 
				$.rup.i18n.app.dialog.label.mostrarOcultarInforme, 
				[
		        	{
		                text: $.rup.i18n.app.botonera.cancelar,
		                click: function () { 
		                    $('#dialogConfirm').rup_dialog('close'); 
		                },
		                btnType: $.rup.dialog.LINK
		                
		            },
			        {
			            text: $.rup.i18n.app.botonera.aceptar,
			            id: "btnOcultar",
			            click: function () {
			            	$('#dialogConfirm').rup_dialog('close');
			            	
			            	const selectedRows  = $("#bandejainformes").rup_table("getSelectedRows");
			    			let accion = selectedRows.oculto16 == '1'?"mostrar":"ocultar";
			    			$.rup_ajax({
			    	        	url: $.rup.CTX_PATH +"informes/"+accion+"/"+$('#bandejainformes').rup_table('getSelectedRows')['idInforme16'],
			    	            type: "POST",            
			    	            dataType: 'json',
			    	            contentType: 'application/json',
			    	            beforeSend: function(){
			    	            	Ad74aUtils.cerrarFeedbacks();
			    	            	Ad74aUtils.bloquearInterfaz();            	
			    				},
			    	            success: function (){
			                		$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.feedback.operacionOK, "ok");
			                		$('#bandejainformes').rup_table("reload");                    
			                  	},
			    				error: function (error) {
			    					Ad74aUtils.desBloquearInterfaz();
			    					$("#rup_feedback_bandejainformes").rup_feedback('set', error.responseJSON || error.responseText, "error");
			    				},
			                    complete: function() {
			                    	Ad74aUtils.desBloquearInterfaz();
			                    }
			    	        });		
			            	
			            },
			            class: 'btn-material btn-material-primary-high-emphasis'
			            
			        },
		        ]
			);							
		}
	};
	
	const reloadButton = {
	text: function () {
			return $.rup.i18n.app.botonera.actualizarListado;
		},
		id: 'actualizarListado', // Campo obligatorio si se quiere usar desde el contextMenu
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView progressButton',
		icon: "mdi-refresh",
		displayRegex: /^\d+$/,
		insideContextMenu: true,
		//type: 'view',
		action: function (e, dt) {
			$("#bandejainformes").rup_table("reload");
		}
	};

	$.downloadDocument = function(oid, nombreDoc){		
		if (oid != null
				&& oid != ''){
			var url = $.rup.CTX_PATH+"informes/downloadInforme/"+oid+"?nombreDoc="+nombreDoc;
			window.open($.rup_utils.setNoPortalParam(encodeURI(url)));	
		}
	}
	
	
	const initDialog = () => {
		
		$('#fecInicio_informes_dialog_table').rup_date({
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss',
			disabled : true
		});
		
		$('#fecFin_informes_dialog_table').rup_date({
			mask: 'dd/mm/yyyy',
			showButtonPanel : true,
			showOtherMonths : true,
			disabled : true
		});
		
		$('#fecEnvioAdmin_informes_dialog_table').rup_date({
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss',
			disabled : true
		});
		
		$("#tipoInforme_informes_dialog_table").rup_combo({
			rowStriping: true,
			ordered: true,
			blank: '',
			customClasses: ['select-material'],
			loadFromSelect:true,
			width: 'auto',
		});
		$("#estado_informes_dialog_table").rup_combo({
			rowStriping: true,
			ordered: true,
			blank: '',
			customClasses: ['select-material'],
			loadFromSelect:true,
			width: 'auto',
		});
		
		
		 if($('div[aria-describedby=dialogBandejaInformes]').length == 1){
		    	$('div[aria-describedby=dialogBandejaInformes]').remove();
		    	$('#dialogBandejaInformes').remove();
		    }
		 
		 $("input[name='_urgente16']").remove();
		 $("input[name='_informeSocial.estaSolaManana02']").remove();
		 $("input[name='_informeSocial.estaSolaTarde02']").remove();
		 $("input[name='_informeSocial.estaSolaNoche02']").remove();
		
		
		 
		$('#dialogBandejaInformes').rup_dialog({
	        type: $.rup.dialog.DIV,
	        autoOpen: false,
	        modal: true,
	        resizable: true,
	        dialogClass: 'custom_full_dialog',
	        title: '<i>'+$.rup.i18n.app.informes.tituloDialogo+'</i>',
	        buttons: [
	            {
	                text: $.rup.i18n.app.botonera.cancelar,
	                click: function () { 
	                    $('#dialogBandejaInformes').rup_dialog('close'); 
	                },
	                btnType: $.rup.dialog.LINK
	                
	            },
	        {
	            text: $.rup.i18n.app.botonera.guardar,
	            id: "btnGuardarInforme",
	            click: function () { 
	            	actualizarInforme();
	            },
	            class: 'btn-material btn-material-primary-high-emphasis'
	            
	        },
	        {
	            text: $.rup.i18n.app.informes.aniadir,
	            id: "btnInsertInforme",
	            click: function () { 
	            	insertInforme();
	            },
	            class: 'btn-material btn-material-primary-high-emphasis'
	            
	        },
	        {
	            text: $.rup.i18n.app.botonera.finalizarInforme,
	            id: "btnFinalizarInforme",
	            click: function () { 
	            	finalizarInforme();
	            },
	            class: 'btn-material btn-material-secondary-high-emphasis'
	            
	        }

	        ],
			open: () => {
				// Añadir iconos a los botones del popup
				$("#btnGuardarInforme").html(`<i class="mdi mdi-content-save"></i> ${$.rup.i18n.app.botonera.guardar}`);
				$("#btnInsertInforme").html(`<i class="mdi mdi-content-save"></i> ${$.rup.i18n.app.botonera.guardar}`);
				$("#btnFinalizarInforme").html(`<i class="mdi mdi-settings"></i> ${$.rup.i18n.app.botonera.finalizarInforme}`);
			}
	    });
		// Inicializar el feedback
		try {
			$("#bandejaInformes_dialog_feedback").rup_feedback("destroy");
		} catch (error) {}

		$("#bandejaInformes_dialog_feedback").rup_feedback(
			{
				type: "ok",
				block: false,
				delay: 3000,
				fadeSpeed: 600,
			}
		);
		
		jQuery.validator.addMethod("vinculo", function(value, element,a) {
			if($("#familiarFallecido02_1_informes_dialog_table").is(":checked") && $("#vinculoFallecido02_informes_dialog_table").val().trim() == ''){
				return false;
			}
			return true;						
		 },$.rup.i18n.base.rup_validate.messages.required);
		
		jQuery.validator.addMethod("convivencia", function(value, element,a) {
			
			let numConvivientes = 0;
			try{
				const ctx = $("#convivencia").rup_table("getContext");
				numConvivientes = ctx.json.rows.length;
			}catch(err){
				numConvivientes = 0;
			}
			if($("#sola02_1_informes_dialog_table").is(":checked") && numConvivientes < 1){
				return false;
			}
			return true;						
		 },$.rup.i18n.app.validaciones.convivenciaObligatorio);
		
		 $("#bandejainformes_dialog_form").rup_validate({
			 feedback:$("#bandejaInformes_dialog_feedback"),
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: true,
				showFieldErrorsInFeedback: true,
			 rules:{
			      "solicitantes.dninombreApellidosBeneficiario":{required:true},      
			      "informeSocial.trabajadorSoc02":{required:true},
			      "ayuntamiento16":{required:true},
			      "unidadBase16":{required:true},
			      "informeSocial.sola02":{required:true, convivencia: true},
			      "informeSocial.relacionEntorno02":{required:true},
			      "informeSocial.familiarFallecido02":{required:true},
			      "informeSocial.visitasFamilia02":{required:true},
			      "informeSocial.visitasAmigos02":{required:true},
			      "informeSocial.frecuenciaSalidas02":{required:true},
			      "informeSocial.periodoSinVisitas02":{required:true},
			      "informeSocial.tiempoSinVisitas02":{required:true},
			      "informeSocial.apreciacion02":{required:true},
			      "informeSocial.vinculoFallecido02": {vinculo: true},
			      "informeSocial.observaciones02": {maxlength: 1750},
			      "fInicio16":{date:true},
			      "fEnvioAdmon16":{date:true},
			      
			 },
			 'highlight': function (element, errorClass, validClass) {
		            if($(element).attr('type') == 'radio'){
		                $(element.form).find("input[type=radio][name='"+$(element).attr('name')+"']").each(function(which){
		                    $(element.form).find("label[for=" + this.id + "]").addClass(errorClass);
		                    $(this).addClass(errorClass);
		                });
		            } else {
		                $(element.form).find("label[for=" + element.id + "]").addClass(errorClass);
		                $(element).addClass(errorClass);
		            }
	        },
	        'unhighlight': function (element, errorClass, validClass) {
	            if($(element).attr('type') == 'radio'){
	            	$(element.form).find("input[type=radio][name='"+$(element).attr('name')+"']").each(function(which){
	                    $(element.form).find("label[for=" + this.id + "]").removeClass(errorClass);
	                    $(this).removeClass(errorClass);
	                });
	            }else {
	            	try{
		                $(element.form).find("label[for=" + element.id + "]").removeClass(errorClass);
		                $(element).removeClass(errorClass);
	            	}catch(err){}
	            }
	        },
		});
		 
		 $("#bandejainformes_dialog_form [ruptype='date']").blur(function(elem) { 

				if(!$(elem.target).valid()){
	                $(elem.target).val('')
	            }

			})
		 
		 
		 $('#dialogSolicitarInformes').rup_dialog({
		        type: $.rup.dialog.DIV,
		        autoOpen: false,
		        modal: true,
		        resizable: true,
		        dialogClass: 'custom_full_dialog',
		        title: '<i>'+$.rup.i18n.app.informes.tituloDialogoSolicitarInforme+'</i>',
		        buttons: [
		        	  {
			                text: $.rup.i18n.app.botonera.cancelar,
			                click: function () { 
			                    $('#dialogSolicitarInformes').rup_dialog('close'); 
			                },
			                btnType: $.rup.dialog.LINK
			                
			            },
			        {
			            text: $.rup.i18n.app.informes.btnSolicitar,
			            id: "btnSolicitarInformesGuardar",
			            click: function () { 
			            	if($("#solicitarinformes_dialog_form").valid()){				            	
			            		let datos = {};
			            		datos= window.form2object($('#solicitarinformes_dialog_form')[0]);
			            		$.rup_ajax({
			            			url: $.rup.CTX_PATH +"informes/solicitarInformeIntervenciones",
			            			type: 'post',
			            			dataType: 'json',
			            			data: JSON.stringify(datos),
			            			contentType: 'application/json',			            			
			            			beforeSend: function(){
			        	            	Ad74aUtils.cerrarFeedbacks();
			        	            	Ad74aUtils.bloquearInterfaz();            	
			        				},
			        	            success: function (){
						        		$('#dialogSolicitarInformes').rup_dialog("close");
			            				$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.informes.informeSolicitado, "ok");
			            				$('#bandejainformes').rup_table("reload");                   
			                      	},
			        				error: function (error) {
			        					$('#solicitarInformes_dialog_feedback').rup_feedback("option", "delay", null);
			        					$("#solicitarInformes_dialog_feedback").rup_feedback('set', error.responseJSON || error.responseText, "error");
			        				},
			                        complete: function() {
			                        	Ad74aUtils.desBloquearInterfaz();
			                        }
			        				
			            		});
			            	}
			            },
			            class: 'btn-material btn-material-primary-high-emphasis'
			            
			        }
		        	],
		 open: () => {
				// Añadir iconos a los botones del popup
				$("#btnSolicitarInformesGuardar").html(`<i class="mdi mdi-content-save"></i> ${$.rup.i18n.app.informes.btnSolicitar}`);
				
				// Resetaer validacion
				$("#solicitarinformes_dialog_form").rup_validate("resetElements");				
				// Resetaer formulario
				$("#solicitarinformes_dialog_form").rup_form("clearForm");		
				
				// Cerrar feedbacks
				Ad74aUtils.cerrarFeedbacks();
				
				$('#idAyuntamiento31_infInt_dialog_table').val(ayuntamiento.idAyuntamiento31);
				$('#ayuntamiento_infInt_dialog_table').val(ayuntamiento.desc);
				$('#nombre_infInt_dialog_table').val(usuarioConectado.nombreCompleto);
				$('#identificador80_infInt_dialog_table').val(usuarioConectado.identificador80);
				$('#telefono16_infInt_dialog_table').val(usuarioConectado.tlfno80);
				$('#email16_infInt_dialog_table').val(usuarioConectado.email80);
				
				Ad74aUtils.number('#telefono16_infInt_dialog_table',{
					"type": "integer",
					"enteros":9,
					"decimals": 0,
				});
				$("#unidadBase16_infInt_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idMunicipio92='+ayuntamiento.municipio.codMunicipio + '&idProvincia92=' + ayuntamiento.municipio.codProvincia + '&idUsuario80=' + usuarioConectado.idUsuario80);
			}
		 });
		 
		// Inicializar el feedback
			try {
				$("#solicitarInformes_dialog_feedback").rup_feedback("destroy");
			} catch (error) {}

			$("#solicitarInformes_dialog_feedback").rup_feedback(
				{
					type: "ok",
					block: false,
					delay: 3000,
					fadeSpeed: 600,
				}
			);
		 
		jQuery.validator.addMethod("idSolicitante", function(value, element,a) {
//			console.log("idSolicitante:" + value);
			if($("#idSolicitante01_informes_dialog_table").val() == ''){
				return false;
			}
			return true;						
		 },$.rup.i18n.app.validaciones.idSolicitante);
			
		 $("#solicitarinformes_dialog_form").rup_validate({
			 feedback:$("#solicitarInformes_dialog_feedback"),
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: true,
				showFieldErrorsInFeedback: true,
			 rules:{
			      "solicitantes.idSolicitante01":{idSolicitante:true},      
			      "ayuntamiento16":{required:true},
			      "unidadBase16":{required:true},		
			      "observaciones16": {maxlength: 1000}
			 }
		});
		 
		 
		 $('#nombreBeneficiario_solicitarInformes_dialog_table').prop("disabled",true);
		 $('#nombre01_informes_dialog_table').prop("disabled",true);
		 $('#apellido101_informes_dialog_table').prop("disabled",true);
		 $('#apellido201_informes_dialog_table').prop("disabled",true);
		 
		 $("#buscarExpedienteBtn").on('click', () => {
			 $("#buscarExpedienteBtn").blur();
			 if($('#expediente_informes_dialog_table').val().length>=14){
				  $.rup_ajax({
		              url: $.rup.CTX_PATH +"informes/obtenerIdExpediente/"+ $("#expediente_informes_dialog_table").val(),
		              type: "POST",            
		              dataType: 'json',
		              contentType: 'application/json',
						beforeSend: function() {
							Ad74aUtils.bloquearInterfaz();
		                },
		                complete: function() {
		                	Ad74aUtils.desBloquearInterfaz();
		                },
		              success: function (data){
							if(data.idExpediente00!=null){
								$('#idExpediente16_informes_dialog_table').val(data.idExpediente00);
								$("#buscarExpedienteBtn i").fadeOut();
								$("#buscarExpedienteBtn i").removeClass("mdi-magnify");
								$("#buscarExpedienteBtn i").addClass("mdi-check verde");
								$("#buscarExpedienteBtn i").fadeIn();
								
								setTimeout(() => {
									$("#buscarExpedienteBtn i").fadeOut();
									$("#buscarExpedienteBtn i").addClass("mdi-magnify");
									$("#buscarExpedienteBtn i").removeClass("mdi-check verde");
									$("#buscarExpedienteBtn i").fadeIn();
								}, 2000);
		                   }
							else{
								try {
									$("#bandejaInformes_dialog_feedback").rup_feedback("destroy");
								} catch (error) {}

								$("#bandejaInformes_dialog_feedback").rup_feedback(
									{
										type: "ok",
										block: false,
										delay: 3000,
										fadeSpeed: 600,
									}
								);
								$("#bandejaInformes_dialog_feedback").rup_feedback("set", $.rup.i18n.app.informes.expedienteNoEncontrado, "error");
								$("#idExpediente16_informes_dialog_table").val('');
								$('#expediente_informes_dialog_table').val('');
							}									                    
		              },
		              error: function(error){ 
						alert("error")

		              }
		        });
				 
			  }
			  else{
				  $("#idExpediente16_informes_dialog_table").val(''); 
				  $('#expediente_informes_dialog_table').val('');
			  }
		 });
		 
		 $("#buscarSolicitanteIntBtn").on('click', () => {
			 
			 $("#buscarSolicitanteIntBtn").blur();
			  if($('#dniSolicitante_infInt_dialog_table').val().length==9){
				  const datos = {"beneficiario": 1};				  
				  $.rup_ajax({
		              url: $.rup.CTX_PATH +"informes/obtenerDatosBeneficiario/"+ $("#dniSolicitante_infInt_dialog_table").val(),
		              type: "POST",            
		              dataType: 'json',
		              data: JSON.stringify(datos),
		              contentType: 'application/json',
						beforeSend: function() {
							Ad74aUtils.cerrarFeedbacks();
							Ad74aUtils.bloquearInterfaz();
		                },
		                complete: function() {
		                	Ad74aUtils.desBloquearInterfaz();
		                },
		              success: function (data){
			
						$('#idSolicitante01_infInt_dialog_table').val('');
						$('#nombre02_infInt_dialog_table').val('');
						$('#apellido102_infInt_dialog_table').val('');
						$('#apellido202_infInt_dialog_table').val('');
						if(data.idSolicitante01!=null){
							$('#nombre01_infInt_dialog_table').val(data.nombre01);
							$('#apellido101_infInt_dialog_table').val(data.apellido101);
							$('#apellido201_infInt_dialog_table').val(data.apellido201);
							$('#idSolicitante01_infInt_dialog_table').val(data.idSolicitante01);
							
							let direccionCompleta = data.direccion!=null?data.direccion + ', ':'';
							direccionCompleta += data.portal!=null?data.portal + ', ':'';
							direccionCompleta += data.piso!=null?data.piso :'';
							direccionCompleta += data.letra!=null?data.letra + ', ':'';
							direccionCompleta += data.cp!=null?data.cp + ' ':'';
							direccionCompleta += data.localidad!=null?data.localidad:'';	
							$("#direccion_layer #direccion_text").val(direccionCompleta);
							$("#direccion_layer").show();
							
							//$('.datosBeneficiario').show();
							$("#buscarSolicitanteIntBtn i").fadeOut();
							$("#buscarSolicitanteIntBtn i").removeClass("mdi-magnify");
							$("#buscarSolicitanteIntBtn i").addClass("mdi-check verde");
							$("#buscarSolicitanteIntBtn i").fadeIn();
							
							setTimeout(() => {
								$("#buscarSolicitanteIntBtn i").fadeOut();
								$("#buscarSolicitanteIntBtn i").addClass("mdi-magnify");
								$("#buscarSolicitanteIntBtn i").removeClass("mdi-check verde");
								$("#buscarSolicitanteIntBtn i").fadeIn();
							}, 2000);
						}
						else{		
							$("#solicitarInformes_dialog_feedback").rup_feedback("option", "delay", null);
							$("#solicitarInformes_dialog_feedback").rup_feedback("set", $.rup.i18n.app.informes.solicitarInformeIntervencionBenefNoEnc, "error");
							
							$("#dniSolicitante_infInt_dialog_table").val(''); 
							$('#nombre01_infInt_dialog_table').val('');
							$('#apellido101_infInt_dialog_table').val('');
							$('#apellido201_infInt_dialog_table').val('');
							
							$("#direccion_layer #direccion_text").val('');
							$("#direccion_layer").hide();
							
							$("#buscarSolicitanteIntBtn i").fadeOut();
							$("#buscarSolicitanteIntBtn i").removeClass("mdi-magnify");
							$("#buscarSolicitanteIntBtn i").addClass("mdi-close rojo");
							$("#buscarSolicitanteIntBtn i").fadeIn();
							
							setTimeout(() => {
								$("#buscarSolicitanteIntBtn i").fadeOut();
								$("#buscarSolicitanteIntBtn i").addClass("mdi-magnify");
								$("#buscarSolicitanteIntBtn i").removeClass("mdi-close rojo");
								$("#buscarSolicitanteIntBtn i").fadeIn();
							}, 2000);
						}
		              },
		              error: function(error){ 
						$("#solicitarInformes_dialog_feedback").rup_feedback("option", "delay", null);
						$("#solicitarInformes_dialog_feedback").rup_feedback("set", error.responseJSON.replaceAll("\"",""), "error");
		              }
		        });	 
			  }else{
					$("#dniSolicitante_infInt_dialog_table").val(''); 
					$('#nombre01_infInt_dialog_table').val('');
					$('#apellido101_infInt_dialog_table').val('');
					$('#apellido201_infInt_dialog_table').val('');
			  }
			
		 });
		 
		 $("#buscarSolicitanteBtn").on('click', () => {

			 $("#buscarSolicitanteBtn").blur();
			  if($('#dniSolicitante_informes_dialog_table').val().length==9){
				  const datos = {"beneficiario": 0};
				  $.rup_ajax({
		              url: $.rup.CTX_PATH +"informes/obtenerDatosBeneficiario/"+ $("#dniSolicitante_informes_dialog_table").val(),
		              type: "POST",            
		              dataType: 'json',
		              data: JSON.stringify(datos),
		              contentType: 'application/json',
						beforeSend: function() {
							Ad74aUtils.cerrarFeedbacks();
							Ad74aUtils.bloquearInterfaz();
		                },
		                complete: function() {
		                	Ad74aUtils.desBloquearInterfaz();
		                },
		              success: function (data){
			
						$('#buscarExpedienteBtn').prop("disabled", false);
			
						$('#idSolicitante01_informes_dialog_table').val('');
						$('#nombre02_informes_dialog_table').val('');
						$('#apellido102_informes_dialog_table').val('');
						$('#apellido202_informes_dialog_table').val('');
						if(data.idSolicitante01!=null){
							$('#nombre01_informes_dialog_table').val(data.nombre01);
							$('#apellido101_informes_dialog_table').val(data.apellido101);
							$('#apellido201_informes_dialog_table').val(data.apellido201);
							$('#idSolicitante01_informes_dialog_table').val(data.idSolicitante01);
							$('#tipoIdentificador01_informes_dialog_table').val(data.tipoIdentificador01);
							$('.datosNuevoBeneficiario').hide();
							$('.datosBeneficiario').show();
							$("#buscarSolicitanteBtn i").fadeOut();
							$("#buscarSolicitanteBtn i").removeClass("mdi-magnify");
							$("#buscarSolicitanteBtn i").addClass("mdi-check verde");
							$("#buscarSolicitanteBtn i").fadeIn();
							
							//$('#buscarExpedienteBtn').prop("disabled", false);
							
							setTimeout(() => {
								$("#buscarSolicitanteBtn i").fadeOut();
								$("#buscarSolicitanteBtn i").addClass("mdi-magnify");
								$("#buscarSolicitanteBtn i").removeClass("mdi-check verde");
								$("#buscarSolicitanteBtn i").fadeIn();
							}, 2000);
						}
						else{							
							$('.datosNuevoBeneficiario').show();
							$('.datosBeneficiario').hide();
							
							$("#buscarSolicitanteBtn i").fadeOut();
							$("#buscarSolicitanteBtn i").removeClass("mdi-magnify");
							$("#buscarSolicitanteBtn i").addClass("mdi-close rojo");
							$("#buscarSolicitanteBtn i").fadeIn();
							
							//$('#buscarExpedienteBtn').prop("disabled", true);
							
							setTimeout(() => {
								$("#buscarSolicitanteBtn i").fadeOut();
								$("#buscarSolicitanteBtn i").addClass("mdi-magnify");
								$("#buscarSolicitanteBtn i").removeClass("mdi-close rojo");
								$("#buscarSolicitanteBtn i").fadeIn();
							}, 2000);
						}
		              },
		              error: function(error){ 
						$('#bandejaInformes_dialog_feedback').rup_feedback("option", "delay", null);
						$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseJSON || error.responseText, "error");
						//alert(error.responseJSON)
		              }
		        });	 
			  }else{
					$("#dniSolicitante_informes_dialog_table").val(''); 
					$('#nombre01_informes_dialog_table').val('');
					$('#apellido101_informes_dialog_table').val('');
					$('#apellido201_informes_dialog_table').val('');
					$('#nombre02_informes_dialog_table').val('');
					$('#apellido102_informes_dialog_table').val('');
					$('#apellido202_informes_dialog_table').val('');
			  }
			
		 });
		 
		 $('#vinculo_layer').hide();
		 $('#tiempoSinVisitas').hide();
		 $('#convivencia_layer').hide();
		 
		 $('[name="informeSocial.sola02"]').on("change",function(){
			 if($('[name="informeSocial.sola02"]:checked').attr("id").split('_')[1] == 1) {
				 $('#convivencia_layer').fadeIn();		
				 loadConvivencia()
			 }else{				 
				 $('#convivencia_layer').fadeOut();
			 }			 
		});
		 
		 $('#familiarFallecido02_0_informes_dialog_table').on("change",function(){
			if($('#familiarFallecido02_0_informes_dialog_table').prop("checked")==true)
				$('#vinculo_layer').fadeOut();
				
			if($('#familiarFallecido02_1_informes_dialog_table').prop("checked")==true)
					$('#vinculo_layer').fadeIn();
		 });
		 
		 $('#familiarFallecido02_1_informes_dialog_table').on("change",function(){
			if($('#familiarFallecido02_0_informes_dialog_table').prop("checked")==true)
				$('#vinculo_layer').fadeOut();
				
			if($('#familiarFallecido02_1_informes_dialog_table').prop("checked")==true)
					$('#vinculo_layer').fadeIn();
		 });	
		 		 
		 
		 $('#periodoSinVisitas02_0_informes_dialog_table').on("change",function(){
			if($('#periodoSinVisitas02_0_informes_dialog_table').prop("checked")==true)
				$('#tiempoSinVisitas').fadeOut();
			
			if($('#periodoSinVisitas02_0_informes_dialog_table').prop("checked")==false)
				$('#tiempoSinVisitas').fadeIn();
			
		 });
		 
		 $('#periodoSinVisitas02_1_informes_dialog_table').on("change",function(){
			if($('#periodoSinVisitas02_0_informes_dialog_table').prop("checked")==true)
				$('#tiempoSinVisitas').fadeOut();
			
			if($('#periodoSinVisitas02_0_informes_dialog_table').prop("checked")==false)
				$('#tiempoSinVisitas').fadeIn();
			
		 });
		
		$('.datosNuevoBeneficiario').hide();
		$('.datosBeneficiario').show();
	}
	
	const actualizarInforme = () =>{
		
		if($("#bandejainformes_dialog_form").valid()){			
			const datos = getDetailFormData();
//			console.log(datos);
			
			$.rup_ajax({
				url: $.rup.CTX_PATH +"informes/updateInformeSocial",
				type: 'post',
				dataType: 'json',
				contentType: 'application/json',
				data: JSON.stringify(datos),
				beforeSend: function() {
					Ad74aUtils.bloquearInterfaz();
				},
				complete: function() {
					Ad74aUtils.desBloquearInterfaz();
				},
				success: function (data) {
					$('#dialogBandejaInformes').rup_dialog('close');
					$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.informes.informeActualizado, "ok");
					$('#bandejainformes').rup_table("reload");      
					
				},
				error: function (error) {
					$('#bandejaInformes_dialog_feedback').rup_feedback("option", "delay", null);
					$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseJSON || error.responseText, "error");
				}
			});
		}
	}
	
	const insertInforme = () =>{
				
		if($("#bandejainformes_dialog_form").valid()){
			
			const datos = getDetailFormData();
//			console.log(datos);
			$.rup_ajax({
	            url: $.rup.CTX_PATH +"informes/insertInformeSocial",
	            type: 'post',
	            data: JSON.stringify(datos),
	            dataType: 'json',
	            contentType: 'application/json',
	            beforeSend: function(){
	            	Ad74aUtils.cerrarFeedbacks();
	            	Ad74aUtils.bloquearInterfaz();            	
				},
	            success: function (){
					$('#dialogBandejaInformes').rup_dialog('close');
            		$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.feedback.operacionOK, "ok");
            		$('#bandejainformes').rup_table("reload");                    
              	},
				error: function (error) {
					$('#bandejaInformes_dialog_feedback').rup_feedback("option", "delay", null);
					$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseJSON || error.responseText, "error");
				},
                complete: function() {
                	Ad74aUtils.desBloquearInterfaz();
                }
	        });
		}
	}
	
	const finalizarInforme = () =>{
		
		Ad74aUtils.openConfirmDialog(
			'dialogConfirm', 
			$.rup.i18n.app.dialog.title.finalizarInforme, 
			$.rup.i18n.app.dialog.label.finalizarInforme,  
			[
				{
	                text: $.rup.i18n.app.botonera.cancelar,
	                click: function () { 
	                    $('#dialogConfirm').rup_dialog('close'); 
	                },
	                btnType: $.rup.dialog.LINK
	                
	            },
	            {
	                text: $.rup.i18n.app.botonera.aceptar,
	                class: 'btn-material btn-material-primary-high-emphasis',
	                click: function () { 
	                	
	                	$('#dialogConfirm').rup_dialog('close'); 
	                	if($("#bandejainformes_dialog_form").valid()){
	            			
	            			const url = $.rup.CTX_PATH +"informes/updateInformeSocial";
	            			
	            			const datos = getDetailFormData();
	            			datos.estado16 = PENDIENTE_APORTAR; 
//	            			console.log(datos);
	            			$.rup_ajax({
	            	            url: url,
	            	            type: 'post',
	            	            data: JSON.stringify(datos),
	            	            dataType: 'json',
	            	            contentType: 'application/json',
	            	            beforeSend: function(){
	            	            	Ad74aUtils.cerrarFeedbacks();
	            	            	Ad74aUtils.bloquearInterfaz();            	
	            				},
	            	            success: function (){
	            					$('#dialogBandejaInformes').rup_dialog('close');
	                        		$('#rup_feedback_bandejainformes').rup_feedback("set", $.rup.i18n.app.feedback.operacionOK, "ok");
	                        		$('#bandejainformes').rup_table("reload");                    
	                          	},
	            				error: function (error) {
	            					$('#bandejaInformes_dialog_feedback').rup_feedback("option", "delay", null);
	            					$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseJSON || error.responseText, "error");
	            				},
	                            complete: function() {
	                            	Ad74aUtils.desBloquearInterfaz();
	                            }
	            	        });
	            		}
	                },
	                
	            }
	        ],
	        'custom_small_dialog'
		);				
	}
	
	const getDetailFormData = () => {
		let datos = {};
		datos = window.form2object($('#bandejainformes_dialog_form')[0]);
		datos.oculto16 = $('#oculto_informes_dialog_table').val();
		if(datos.tipoInforme16 == TIPOIINFORMESOCIAL){
			datos.oculto16 = 0;			
		}
		datos.urgente16 = $('#urgente_informes_dialog_table').is(":checked")?1:0;
		
		datos.informeSocial.sola02=$('#sola02_0_informes_dialog_table').is(":checked")?0:1;
		datos.informeSocial.estaSolaManana02=$('#estaSolaManana02_informes_dialog_table').is(":checked")?1:0;
		datos.informeSocial.estaSolaTarde02=$('#estaSolaTarde02_informes_dialog_table').is(":checked")?1:0;
		datos.informeSocial.estaSolaNoche02=$('#estaSolaNoche02_informes_dialog_table').is(":checked")?1:0;
		
		datos.informeSocial.relacionEntorno02 = $('[name="informeSocial.relacionEntorno02"]:checked').attr("id").split('_')[1];	
		
		datos.informeSocial.familiarFallecido02=$('#familiarFallecido02_1_informes_dialog_table').is(":checked")?1:0;
		
		datos.informeSocial.visitasFamilia02 = $('[name="informeSocial.visitasFamilia02"]:checked').attr("id").split('_')[1];

		datos.informeSocial.visitasAmigos02 = $('[name="informeSocial.visitasAmigos02"]:checked').attr("id").split('_')[1];

		datos.informeSocial.frecuenciaSalidas02 = $('[name="informeSocial.frecuenciaSalidas02"]:checked').attr("id").split('_')[1];
	
		datos.informeSocial.periodoSinVisitas02=$('#periodoSinVisitas02_0_informes_dialog_table').is(":checked")?0:1;

		if($('[name="informeSocial.tiempoSinVisitas02"]:checked').length > 0){			
			datos.informeSocial.tiempoSinVisitas02 = $('[name="informeSocial.tiempoSinVisitas02"]:checked').attr("id").split('_')[1];
		}

		datos.informeSocial.apreciacion02=$('#apreciacion02_0_informes_dialog_table').is(":checked")?1:0;
		
		return datos;
	}
	

	const openDialogDetalleInforme = (oper, idInforme) => {	
		
		$("#bandejainformes_processing").show();
		const id = idInforme || ($('#bandejainformes').rup_table('getSelectedRows')['idInforme16']);
//		console.log("idInforme: "+ idInforme + ";id: "+id );
		//const id=($('#bandejainformes').rup_table('getSelectedRows')['idInforme16']);
		const url =$('#bandejainformes').rup_table('getSelectedRows')['tipoInforme16']==TIPOIINFORMESOCIAL? '../informes/detail/'+id:'../informes/detailNoInfSoc/'+id;

		const divTitleDialog = $("div[aria-describedby='dialogBandejaInformes'] .ui-dialog-title");
		const divDialog = $("div[aria-describedby='dialogBandejaInformes']");
		divDialog.removeClass("custom_dialog_urgente");
		divTitleDialog.html('<i>'+$.rup.i18n.app.informes.tituloDialogo+'</i>');

		
		$("#convivencia_layer").hide();	
		
		// Plegar todo
		$("[id^='plegado']:not(.plegado)").prev(".plegable").click();
		
		// Resetaer validacion
		$("#bandejainformes_dialog_form").rup_validate("resetElements");
		
		// Resetaer formulario
		$("#bandejainformes_dialog_form").rup_form("clearForm");
		
		// Reset la búsqueda de expediente
		$("#busquedaExpediente").html('');
		$("#expediente_filter_layer").addClass("plegado");
		$("#detalleAportacionLayer").removeClass("on");
		$("#overlay-buscar").addClass("d-none");
		
		// Cerrar feedbacks
		Ad74aUtils.cerrarFeedbacks();
		
		const loadingDiv = `<div class="row">
				<div class="col col-sm text-center">
				<div class="col col-sm text-center processing-container">
				<span class="loading">${$.rup.i18n.base.rup_blockUI.cargando}</span>
			</div>
		</div>`;
		
		if(oper=="edit"){
			
			isNewInfSocial = false;
			Ad74aUtils.bloquearInterfaz();
			
			if($('#bandejainformes').rup_table('getSelectedRows')['tipoInforme16']==TIPOIINFORMESOCIAL || $('#bandejainformes').rup_table('getSelectedRows')['tipoInforme16']==TIPOINFORMEINT){
				$("#situacion_layer").show();
				$("#apreciaciones_layer").show();
				$("#expediente_layer").show();
				
				$("#buscarExpedienteBtn").unbind("click");
				$("#buscarExpedienteBtn").bind("click", () => {
					if( $("#expediente_filter_layer").hasClass("plegado")){									
						$("#busquedaExpediente").html(loadingDiv);
						$("#busquedaExpediente").load("../informes/buscarExpediente");
						$("#detalleAportacionLayer").addClass("on");
						$("#overlay-buscar").removeClass("d-none");
						$("#expediente_filter_layer").toggleClass("plegado");
					}
				});
				
				$("#clearExpedienteBtn").unbind("click");
				$("#clearExpedienteBtn").bind("click", () => {
					$("#idExpediente16_informes_dialog_table").val("");
					$("#expediente_informes_dialog_table").val("");
//					$("#numExpediente00Buscar").val("");
					$("#clearExpedienteBtn").addClass("d-none");
				});
				
			}else{				
				$("#situacion_layer").hide();
				$("#apreciaciones_layer").hide();
				$("#expediente_layer").hide();
				
			}
			
			if($('#bandejainformes').rup_table('getSelectedRows')['tipoInforme16']==TIPOINFORMEINT){
				$('#situacion_layer').hide();
				$('#apreciaciones_layer').hide();
				//$('#observaciones_layer').hide();
			}
//			else{
//				$('#situacion_layer').show();
//				$('#apreciaciones_layer').show();
//				//$('#observaciones_layer').show();
//			}
			
			const ajaxData = {
					'url': url,
					'type': 'POST',
					'contentType': 'application/json',
					'dataType': 'json',
					success: function (data) {
						const estado = (isSSB && data.tipoInforme16 == TIPOINFORMEINT && data.estado16 >= SOLICITADO_PROVEEDOR)?EN_TRAMITACION_DESC.toUpperCase():data.estadoDesc.toUpperCase();
						let title = '';	
						try {
							title = `${$.rup.i18n.app.informes.tituloDialogo}: 
								${data.tipoInformeDesc} (${estado}) / ${data.dninombreApellidosBeneficiario}
								${(data.urgente16 == 1)
									? '<span class="mdi mdi-clock-fast " style="font-size: 2.5rem;margin-left: 10px;position: absolute;top: 0px;"></span>'
									:''
								}							
							`;
							
							if(data.urgente16 == 1) {
								divDialog.addClass("custom_dialog_urgente");
							} else {
								divDialog.removeClass("custom_dialog_urgente");						
							}
												
						} catch (e) {
							title = $.rup.i18n.app.dialog.title.tituloDialogo;
						}							
						divTitleDialog.html( title );
						
//						console.log(data);
//						console.log(data.idUnidadBase16);
						$.rup_utils.populateForm($.rup_utils.jsontoarray(data), "#bandejainformes_dialog_form");		
						
						if(isSSB && data.tipoInforme16==TIPOINFORMEINT && data.estado16 >= SOLICITADO_PROVEEDOR && data.estado16 <= ENVIADO) {
							$("#estado_informes_dialog_table").rup_combo('setRupValue', EN_TRAMITACION);
						}
						if(data.usuario.idUsuario80==undefined && data.usuario.idUsuario80==null){
							$('#datosTrabajadorSocial').hide();
						}else{
							$('#datosTrabajadorSocial').show();
						}
						
						if(data.solicitantes.idSolicitante01!=null){								
							$('.datosNuevoBeneficiario').hide();
							$('.datosBeneficiario').show();
							
							
							let direccionCompleta = data.direccion!=null?data.direccion + ', ':'';
							direccionCompleta += data.portal!=null?data.portal + ', ':'';
							direccionCompleta += data.piso!=null?data.piso :'';
							direccionCompleta += data.letra!=null?data.letra + ', ':'';
							direccionCompleta += data.cp!=null?data.cp + ' ':'';
							direccionCompleta += data.localidad!=null?data.localidad:'';							
							
							$("#direccion_layer #direccion_text").val(direccionCompleta);
							$("#direccion_layer").show();
						}
						else{							
							$('.datosNuevoBeneficiario').show();
							$('.datosBeneficiario').hide();
							$("#direccion_layer").hide();
						}
						
						if(data.informeSocial!=null){				
							
							
							if(data.informeSocial.sola02==0){									
								$("#convivencia_layer").fadeOut();
							}else{
								$("#convivencia_layer").fadeIn();
								loadConvivencia();
							}
							
							if(data.informeSocial.familiarFallecido02 == 1){
								$('#vinculo_layer').show();
							}else{
								$('#vinculo_layer').hide();
							}
							
							if(data.informeSocial.periodoSinVisitas02 == 1){
								$('#tiempoSinVisitas').show();
							}else{
								$('#tiempoSinVisitas').hide();
							}
							
//							Ad74aUtils.number('#telefono16_informes_dialog_table',{
//								"type": "integer",
//								"enteros":9,
//								"decimals": 0,
//							});
						}
						
//						console.log(data.idExpediente16);
						if(data.idExpediente16 != null) {
							$("#clearExpedienteBtn").removeClass("d-none");
						}else{
							$("#clearExpedienteBtn").addClass("d-none");
						}
						
						$("#bandejainformes_processing").hide();
						
						initDocumento(data);
						$('#dialogBandejaInformes').rup_dialog('open');
						
						controlEstadoFormulario(data);
						
						// BOTONES
						if((data.tipoInforme16==TIPOIINFORMESOCIAL && data.estado16>INICIADO)
							|| data.tipoInforme16==TIPOINFORMESUICIDIO 
							|| data.tipoInforme16==TIPOINFORMEINT
						) {					
							$('#btnGuardarInforme').hide();
						}else{
							$('#btnGuardarInforme').show();					
						}
						
						$('#btnInsertInforme').hide();
						
						
						if(data.tipoInforme16==TIPOIINFORMESOCIAL && data.estado16==INICIADO) {
							$('#btnFinalizarInforme').show();
						}else{					
							$('#btnFinalizarInforme').hide();
						}
						
						Ad74aUtils.desBloquearInterfaz();

					},
					error: function (error) {
						//alert(error.responseJSON)
						$("#bandejaInformes_processing").hide();
						$('#dialogBandejaTelematica').rup_dialog('close');
						$("#rup_feedback_bandejatelematica").rup_feedback('set', error.responseJSON, "error");
						Ad74aUtils.desBloquearInterfaz();
					}
				};
				
				$.rup_ajax(ajaxData);				
				
		} else if(oper=="add"){
			
			isNewInfSocial = true;
			
			$("#situacion_layer").show();
			$("#apreciaciones_layer").show();
			$("#expediente_layer").show();
			$("#direccion_layer #direccion_text").val('');
			$("#direccion_layer").hide();
			
			$("#buscarExpedienteBtn").unbind("click");
			$("#buscarExpedienteBtn").bind("click", () => {
				if( $("#expediente_filter_layer").hasClass("plegado")){									
					$("#busquedaExpediente").html(loadingDiv);
					$("#busquedaExpediente").load("../informes/buscarExpediente");
					$("#detalleAportacionLayer").addClass("on");
					$("#overlay-buscar").removeClass("d-none");
					$("#expediente_filter_layer").toggleClass("plegado");
				}
			});
			
			$("#clearExpedienteBtn").unbind("click");
			$("#clearExpedienteBtn").bind("click", () => {
				$("#idExpediente00Detail").val("");
				$("#numExpediente00Detail").val("");
				$("#numExpediente00Buscar").val("");
				$("#clearExpedienteBtn").addClass("d-none");
			});
			
			
			try{
				$('#documento-layer #fileupload_only').rup_upload("destroy");
			}catch(e){}
			
			$('#button-layer').hide();	
			$('#aportar-layer').hide();	
			$('#link-layer').hide();		
			$('#documento-layer').hide();
			
			modoEdicion();
			
			const divTitleDialog = $("div[aria-describedby='dialogBandejaInformes'] .ui-dialog-title");
			divTitleDialog.html('<i>'+$.rup.i18n.app.informes.tituloDialogoAniadir+'</i>');
		     
		    $('.datosNuevoBeneficiario').hide();
			$('.datosBeneficiario').show();
			
//		    Ad74aUtils.number('#telefono16_informes_dialog_table',{
//				"type": "integer",
//				"enteros":9,
//				"decimals": 0,
//			});
		    
		    $('#tipoInforme_informes_dialog_table').rup_combo("setRupValue",TIPOIINFORMESOCIAL);			
			$('#estado_informes_dialog_table').rup_combo("setRupValue",INICIADO);
		     
			// BOTONES
			$('#btnGuardarInforme').hide();
			$('#btnInsertInforme').show();
			$('#btnFinalizarInforme').hide();
			
			$("#bandejainformes_processing").hide();
			$('#dialogBandejaInformes').rup_dialog('open');
			$('#ayuntamiento_informes_dialog_table').val(ayuntamiento.desc);
			$('#nombre_informes_dialog_table').val(usuarioConectado.nombreCompleto);
			$('#identificador80_informes_dialog_table').val(usuarioConectado.identificador80);
			$('#telefono16_informes_dialog_table').val(usuarioConectado.tlfno80);
			$('#email16_informes_dialog_table').val(usuarioConectado.email80);
			$('#fecInicio_informes_dialog_table').rup_date("setDate", new Date());
			
			$("#idInfSocial02_informes_dialog_table").val('');
			$("#idExpediente16_informes_dialog_table").val('');
			$('#tiempoSinVisitas').hide();
			$('#vinculo_layer').hide();
			$("#convivencia_layer").hide();		
			$("#unidadBase16_informes_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idMunicipio92='+ayuntamiento.municipio.codMunicipio + '&idProvincia92=' + ayuntamiento.municipio.codProvincia + '&idUsuario80=' + usuarioConectado.idUsuario80);
			$("#unidadBase16_infInt_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idMunicipio92='+ayuntamiento.municipio.codMunicipio + '&idProvincia92=' + ayuntamiento.municipio.codProvincia + '&idUsuario80=' + usuarioConectado.idUsuario80);
		}		
	}
	
	const initDocumento = (data) => {
		
//		console.log(documento);
		const documento = data.documentosInforme;
		
		// No se pq le mete este estilo
		$("#generarDocumentoInformes, #enviarADssInformes").removeClass("btn-material-primary-low-emphasis");
		//$("#generarDocumentoInformes, #enviarADssInformes").removeClass("btn-material-sm");
		
		$('#button-layer').hide();	
		$('#aportar-layer').hide();	
		$('#link-layer').hide();		
		$('#documento-layer').hide();
		
		if(data.estado16==PENDIENTE_APORTAR){
						
			$('#documento-layer').show();
			$('#button-layer').show();
			$('#aportar-layer').show();
			$('#link-layer').hide();
			
			if(data.tipoInforme16 == TIPOIINFORMESOCIAL) {				
				$("#generarDocumentoInformes").prop("disabled", false);
				$("#generarDocumentoInformes").bind('click', () => {
//				const url = $.rup.CTX_PATH +"informes/generarDocumento/"+$('#bandejainformes').rup_table('getSelectedRows').informeSocial['idInfSocial02'];
					const url = $.rup.CTX_PATH +"informes/generarDocumento/"+data.informeSocial.idInfSocial02;
					window.open($.rup_utils.setNoPortalParam(encodeURI(url)));				
				});
			}else {
				$("#generarDocumentoInformes").hide();
			}
			
			if(isSSB && data.tipoInforme16 != TIPOIINFORMESOCIAL) {
				$('#documento-layer').hide();
			}else {
				
				$("#enviarADssInformes").prop("disabled", true);
				$("#enviarADssInformes").unbind('click');
				
				const urlAportar = 'aportar/'+$("#idInforme16_informes_dialog_table").val();  

//				// Permitir solo 1 documento
//				$("#file_only").click(function() {
//					document.getElementById("file_only").value = null;
//					$("#documento-layer #fileupload_only .list-group")[0].innerHTML = '';
//				});
				
				UploadFile.init("documento", {
		            selectButton: {                    
		                "text": $.rup.i18n.app.botonera.seleccionar,
		                "icon": "mdi mdi-plus",
		                "class": "btn-material-primary-high-emphasis",
		            },
		            uploadButton: {
		                "text": $.rup.i18n.app.botonera.aportar,
		                "icon": "mdi mdi-upload",
		                "class": "btn-material-primary-high-emphasis",
		            },
		            "extensions": ['.pdf'],
		            "submitInForm": false,
		            "url": urlAportar,
		            data: () => {
		            	return { 
		            		"id": $("#idInforme16_informes_dialog_table").val()
		            	}
		            },
		            start : function (data) {
						Ad74aUtils.bloquearInterfaz();
					},
					done: function (data) {
						$("#bandejaInformes_dialog_feedback").rup_feedback('set', $.rup.i18n.app.feedback.documentoAportadoOk, "ok");
						$('#bandejainformes').rup_table("reload");
						openDialogDetalleInforme("edit", $("#idInforme16_informes_dialog_table").val());
						UploadFile.reset("documento");
						//Ad74aUtils.desBloquearInterfaz();		            
					},
					fail: function (data) {
						$("#bandejaInformes_dialog_feedback").rup_feedback('set', data, "error");
						UploadFile.reset("documento");
						Ad74aUtils.desBloquearInterfaz();
					},
		        });
				
						    
			}
			
		}else if(data.estado16==PENDIENTE_ENVIAR
				|| data.estado16==ENVIADO){
			
			$('#documento-layer').show();			
			$('#button-layer').show();
			$('#link-layer').show();
			
			$("#generarDocumentoInformes").prop("disabled", true);
			$("#generarDocumentoInformes").unbind('click');
			
			if(data.tipoInforme16 == TIPOIINFORMESOCIAL) {
				$("#generarDocumentoInformes").show();
			}else{
				$("#generarDocumentoInformes").hide();
			}
			
			if(isSSB && data.tipoInforme16 != TIPOIINFORMESOCIAL) {
				$('#documento-layer').hide();
			}else {
				
				if(data.estado16==ENVIADO) {
					$("#enviarADssInformes").prop("disabled", true);
					$("#enviarADssInformes").unbind('click');
				}else{				
					$("#enviarADssInformes").prop("disabled", false);
					$("#enviarADssInformes").bind('click', () => {
						Ad74aUtils.openConfirmDialog(
								'dialogConfirm', 
								$.rup.i18n.app.dialog.title.enviarDSS, 
								$.rup.i18n.app.dialog.label.enviarDSS,  
								[
									{
										text: $.rup.i18n.app.botonera.cancelar,
										click: function () { 
											$('#dialogConfirm').rup_dialog('close'); 
										},
										btnType: $.rup.dialog.LINK
										
									},
									{
										text: $.rup.i18n.app.botonera.aceptar,
										class: 'btn-material btn-material-primary-high-emphasis',
										click: function () { 
											
											$('#dialogConfirm').rup_dialog('close'); 					                	
											$.rup_ajax({
												url: $.rup.CTX_PATH +"informes/enviarDSS/"+data.idInforme16,
												type: "POST",            
												dataType: 'json',
												contentType: 'application/json',
												beforeSend: function() {
													Ad74aUtils.bloquearInterfaz();
												},
												success: function (){
													$('#dialogBandejaInformes').rup_dialog('close');
													$("#rup_feedback_bandejainformes").rup_feedback('set', $.rup.i18n.app.feedback.enviadoADSSOk, "ok");
													//openDialogDetalleInforme("edit");
													$('#bandejainformes').rup_table("reload");																					
													Ad74aUtils.desBloquearInterfaz();
												},
												error: function(error){ 
													//console.log(error);
													Ad74aUtils.desBloquearInterfaz();
													$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseText, "error");							
												}
											});	
										},
										
									}
									],
									'custom_small_dialog'					
						);
					});
				}
				
//				console.log(documento);
				let borrarDoc = '';
				if((isSSB && data.tipoInforme16 == TIPOIINFORMESOCIAL && data.estado16 == PENDIENTE_ENVIAR)
						|| (isPS && data.tipoInforme16 == TIPOINFORMEINT && data.estado16 == PENDIENTE_ENVIAR)
						|| (isPS && data.tipoInforme16 == TIPOINFORMESUICIDIO && data.estado16 == PENDIENTE_ENVIAR)) {
					borrarDoc = `
					<a id="borrarDocumento_${data.idInforme16}_${documento.idDocInforme17}" style="cursor: pointer;">
						<span class="mdi mdi-trash-can-outline rojo" style="font-size: 1.5rem;" title="${$.rup.i18n.app.informes.borrarDocumento}"></span>					
					</a>`; 
				}
				$("#link-layer #documento_table tbody").html(`
						<tr class="even">
							<td>${idioma == 'es'? documento.maestroTiposDoc.descEs36: documento.maestroTiposDoc.descEu36}</td>
							<td class="text-left"><a href='javascript:$.downloadDocument("${documento.oid17}", "${documento.nombreDoc17}");'>${documento.nombreDoc17}</a></td>										
							<td class="text-center">${documento.fAlta17}</td>										
							<td class="text-center">${documento.usuAlta17}</td>		
							<td width="30px" class="text-center">${borrarDoc}</td>				
						</tr>
				`);
				
				$(`#borrarDocumento_${data.idInforme16}_${documento.idDocInforme17}`).unbind("click");
				$(`#borrarDocumento_${data.idInforme16}_${documento.idDocInforme17}`).bind("click", () => {
					Ad74aUtils.openConfirmDialog(
							'dialogConfirm', 
							$.rup.i18n.app.dialog.title.borrarDocumentoInforme, 
							$.rup.i18n.app.dialog.label.borrarDocumentoInforme,  
							[
								{
									text: $.rup.i18n.app.botonera.cancelar,
									click: function () { 
										$('#dialogConfirm').rup_dialog('close'); 
									},
									btnType: $.rup.dialog.LINK
									
								},
								{
									text: $.rup.i18n.app.botonera.aceptar,
									class: 'btn-material btn-material-primary-high-emphasis',
									click: function () { 
										
										$('#dialogConfirm').rup_dialog('close');
										let datos = {
											"idInforme16": data.idInforme16,
											"documentosInforme": {
												"idDocInforme17": documento.idDocInforme17
											}
										}
										$.rup_ajax({
											url: $.rup.CTX_PATH +"informes/borrarDocumento",
											type: "POST",            
											data: JSON.stringify(datos),
											dataType: 'json',
											contentType: 'application/json',
											beforeSend: function() {
												Ad74aUtils.bloquearInterfaz();
											},
											success: function (){
												//$('#dialogBandejaInformes').rup_dialog('close');
												$("#rup_feedback_bandejainformes").rup_feedback('set', $.rup.i18n.app.feedback.enviadoADSSOk, "ok");
												openDialogDetalleInforme("edit", data.idInforme16);
												$('#bandejainformes').rup_table("reload");																					
												//Ad74aUtils.desBloquearInterfaz();
											},
											error: function(error){ 
												//console.log(error);
												Ad74aUtils.desBloquearInterfaz();
												$("#bandejaInformes_dialog_feedback").rup_feedback('set', error.responseText, "error");							
											}
										});	
									},
									
								}
								],
								'custom_small_dialog'					
					);
				});
			}
			
			
		} else if(data.estado16>=ENVIADO){
			$('#documento-layer').show();
			$('#link-layer').show();
		}
	}
	
	const modoConsulta = (tipo, data) => {
		MODOCONSULTA = true;
		MODOEDICION = false;
		console.log("Modo consulta");
		$("#bandejainformes_dialog_form input, #bandejainformes_dialog_form textarea").prop("disabled", true);
		
		$('#tipoInforme_informes_dialog_table').rup_combo("disable");
		$('#estado_informes_dialog_table').rup_combo("disable");
		$('#fecInicio_informes_dialog_table').prop("disabled",true);
		$('#fecFin_informes_dialog_table').prop("disabled",true);
		$('#fecEnvioAdmon_informes_dialog_table').prop("disabled",true);
		
		$('#nombre01_informes_dialog_table').prop("disabled",true);
		$('#apellido101_informes_dialog_table').prop("disabled",true);
		$('#apellido201_informes_dialog_table').prop("disabled",true);
		$('#identificador80_informes_dialog_table').prop("disabled",true);
		$('#nombre_informes_dialog_table').prop("disabled",true);
		$('#ayuntamiento_informes_dialog_table').prop("disabled",true);

		$('#btnGuardarInforme').prop("disabled", true);
		$('#btnInsertInforme').prop("disabled", true);
		$('#btnFinalizarInforme').prop("disabled", true);
		$('#buscarSolicitanteBtn').prop("disabled", true);
		$('#buscarExpedienteBtn').prop("disabled", true);
		$('#clearExpedienteBtn').prop("disabled", true);
		$('#clearExpedienteBtn').addClass('d-none');
		$("#unidadBase16_informes_dialog_table").rup_combo("refresh");
		if(data!=null && data.idUnidadBase16!=null){
			
			$("#unidadBase16_informes_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idUnidadBase92='+$('#bandejainformes').rup_table("getSelectedRows")['idUnidadBase16']);
			$("#unidadBase16_infInt_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idUnidadBase92='+$('#bandejainformes').rup_table("getSelectedRows")['idUnidadBase16']);
			$.rup_utils.populateForm($.rup_utils.jsontoarray(data), "#bandejainformes_dialog_form");
			$("#unidadBase16_informes_dialog_table").rup_combo("disable");
			$("#unidadBase16_infInt_dialog_table").rup_combo("disable");
			
		}else{
			$("#unidadBase16_informes_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes');
			$("#unidadBase16_infInt_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes');
			$("#unidadBase16_informes_dialog_table").rup_combo("disable");
			$("#unidadBase16_infInt_dialog_table").rup_combo("disable");
		}

	}
	
	const modoEdicion = (tipo, data) => {
		MODOCONSULTA = false;
		MODOEDICION = true;
		console.log("Modo edición");
		
		$("#bandejainformes_dialog_form input, #bandejainformes_dialog_form textarea").prop("disabled", false);
		
		$('#tipoInforme_informes_dialog_table').rup_combo("disable");
		$('#estado_informes_dialog_table').rup_combo("disable");
		$('#fecInicio_informes_dialog_table').prop("disabled",true);
		$('#fecFin_informes_dialog_table').prop("disabled",true);
		$('#fecEnvioAdmon_informes_dialog_table').prop("disabled",true);
		
		$('#nombre01_informes_dialog_table').prop("disabled",true);
		$('#apellido101_informes_dialog_table').prop("disabled",true);
		$('#apellido201_informes_dialog_table').prop("disabled",true);
		$('#identificador80_informes_dialog_table').prop("disabled",true);
		$('#nombre_informes_dialog_table').prop("disabled",true);
		$('#ayuntamiento_informes_dialog_table').prop("disabled",true);
	
		$('#btnGuardarInforme').prop("disabled", false);
		$('#btnInsertInforme').prop("disabled", false);
		$('#btnFinalizarInforme').prop("disabled", false);
		$('#buscarSolicitanteBtn').prop("disabled", false);	
		$('#buscarExpedienteBtn').prop("disabled", true);
		
		$("#unidadBase16_informes_dialog_table").rup_combo("refresh");
		if(data!=null && data.idUnidadBase16!=null){
			$("#unidadBase16_informes_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idMunicipio92='+ayuntamiento.municipio.codMunicipio + '&idProvincia92=' + ayuntamiento.municipio.codProvincia + '&idUsuario80=' + usuarioConectado.idUsuario80);
			$("#unidadBase16_infInt_dialog_table").rup_combo("setSource",$.rup.CTX_PATH + 'combo/unidadesBaseInformes?idMunicipio92='+ayuntamiento.municipio.codMunicipio + '&idProvincia92=' + ayuntamiento.municipio.codProvincia + '&idUsuario80=' + usuarioConectado.idUsuario80);
			$.rup_utils.populateForm($.rup_utils.jsontoarray(data), "#bandejainformes_dialog_form");
		}
		if(tipo == TIPO_MODO_0) {
			
			$('#identificador80_informes_dialog_table').prop("disabled",true);
			$('#nombre_informes_dialog_table').prop("disabled",true);
			$('#ayuntamiento_informes_dialog_table').prop("disabled",true);
			
			if(isNewInfSocial){
				$('#buscarExpedienteBtn').prop("disabled", false);
			}else if($("#idSolicitante01_informes_dialog_table").val() == '') {
				$('#buscarExpedienteBtn').prop("disabled", true);
				$('#clearExpedienteBtn').prop("disabled", false);
				$('#clearExpedienteBtn').addClass('d-none');
			}			
			
		}
		
		
	}
	
	const mostrarBotones=()=>{
		misBotones.push(btnVerEditar);

		//TÉCNICO DSS, DIRECTOR DSS O ADMINISTRADOR
		if(isDSS||isAdmin||isDirector){
			misBotones.push(btnOcultarMostrar);			
			$('#trabajadorSolcial_informes_filter_table_wrapper').hide();
		}
		
		//DIRECCION DSS
		 if(isDSS){
			$('#trabajadorSolcial_informes_filter_table_wrapper').hide();
		}
		
		// De momento lo quitamos ya que no le vemos sentido al no ser SSB y no tner ayto. asociado
//		if(isAdmin){
//			misBotones.push(btnNuevoInformeSocial);
//		}
		
		//TÉCNICO SSB
		 if(isSSB){
			misBotones.push(btnNuevoInformeSocial);
			misBotones.push(btnSolicitarInformeIntervenciones);
			
			//misBotones.push(btnGenerarDocumento);
			//misBotones.push(btnAportar);			
			//misBotones.push(btnEnviarADss);
			
			misBotones.push(btnEliminar);
			$('#trabajadorSolcial_informes_filter_table_wrapper').show();
			$('#solicitante_informes_filter_table_wrapper').hide();
			
			$('#mostrarOcultos_informes_filter_table').prop("checked",false);
			$('#mostrarOcultos_informes_filter_table_wrapper').hide();
		}	
		 
		//TÉCNICO PS
		 if(isPS){
			//misBotones.push(btnAportar);
			//misBotones.push(btnEnviarADss);
			
			 misBotones.push(btnEliminar);
			$('#mostrarOcultos_informes_filter_table').prop("checked",false);
			$('#mostrarOcultos_informes_filter_table_wrapper').hide();
			$('#trabajadorSolcial_informes_filter_table_wrapper').show();
		}
		 
		 misBotones.push(reloadButton);
	}
	
	const loadConvivencia = () => {
		
//		console.log("loadConvivencia");
		
		try {
			$("#convivencia").DataTable().destroy();
		} catch (error) {}
		
		let tableColModels = [                    
			{ name: "idConviviente82", index: "idConviviente82", editable: false, hidden: true },
			{ name: "idInfSocial82", index: "idInfSocial82", editable: false, hidden: true },
			{ name: "nombreApellidos82", index: "nombreApellidos82", editable: true, hidden: false, orderable: false, },
			{ name: "parentesco82",	index: "parentesco82", editable: true, hidden: false, orderable: false,	},
			{ 
				name: "fNacimiento82", 
				index: "fNacimiento82", 
				editable: true, 
				hidden: false, 
				orderable: false, 
				rupType: 'date',
				editoptions: {
					yearRange: 'c-120:c',
					mask: 'dd/mm/yyyy',
					showButtonPanel : true,
					showOtherMonths : true,
	            },
			}						
		];
		
		if($("#idInfSocial02_informes_dialog_table").val() == '' 
				|| ($("#bandejainformes").rup_table('getSelectedRows')['tipoInforme16']==TIPOIINFORMESOCIAL && $("#idInfSocial02_informes_dialog_table").val() != '')){
			
			const urlBase = $.rup.CTX_PATH +"convivientesinfsoci/"+($("#idInfSocial02_informes_dialog_table").val() == '' ? 0: $("#idInfSocial02_informes_dialog_table").val());
			$("#convivencia").attr("data-url-base", urlBase);
			
			if($("#idInforme16_informes_dialog_table").val() == ''){
				$.rup_ajax({
    	        	url: $.rup.CTX_PATH +"convivientesinfsoci/clear",
    	            type: "GET",                	            
    	            success: function (){
                		console.log("Session cleared");                    
                  	}
    	        });	
			}
			
			const editParams = {
				// Propiedades de configuración del plugin inlineEdit
				validate: {
					messages: {
						"nombreApellidos82": $.rup.i18n.app.informes.convivientes.nombre,
						"parentesco82": $.rup.i18n.app.informes.convivientes.parentesco,
						"fNacimiento82": $.rup.i18n.app.informes.convivientes.fecha
					},
					rules: {
						'nombreApellidos82': {
							required: true,
							maxlength: 200
						},
						'parentesco82': {
							maxlength: 50
						},
						'fNacimiento82': {
							required: true,
							date: true
						}
					},
					
				},
				confirmDialogs: {
					saveDialog: false,
					cancelDialog: false,
					deleteDialog: true
				}
			}
			
			const FN_convivenciaEdit = () => {
				if($("#idInfSocial02_informes_dialog_table").val() == ''
					||
					($("#bandejainformes").rup_table('getSelectedRows')['tipoInforme16']==TIPOIINFORMESOCIAL && $("#idInfSocial02_informes_dialog_table").val() != ''
						&& $("#bandejainformes").rup_table('getSelectedRows')['estado16']==INICIADO && (isSSB || isAdmin))) {
//					console.log("Editable");
					return false;
				}	
//				console.log("No editable");
				return true;
			}
			
			const tableConvivencia = $("#convivencia").rup_table({
				colReorder: {
					fixedColumnsLeft: 1
				},
				colModel: tableColModels,
				columnDefs : [
					{ 
						"targets": 2,
						"width": "40%",					
					},
					{
						"targets": 3,
						"width": "35%",
					},
					{
						"targets": 4,
						"width": "25%",
					},
				],
				primaryKey: "idConviviente82",
				filter: "noFilter",
				noEdit: FN_convivenciaEdit(),
				createTooltipBody: false,
				inlineEdit: editParams,
				select: {
					activate: true
				},
				"pageLength": 50,
				dom: 't<"container-fluid paginationContainer"' +
				  '<"row mx-0"' +
				  '<"col-6 order-3 text-right align-self-center col-sm-5 order-sm-2 col-xl-2 order-xl-1 text-xl-left">' +
				  '<"d-none"p>' +
				  '<"col-12 text-center"i>' +
				  '>' +
				  '>' +
				  'r',
				buttons: {
					activate: true,
					blackListButtons: ['reportsButton', 'cloneButton', 'copyButton'],                        
				},
				order: [[0, "asc"]],
			});
			
			
		}	
			
	}
	
	const controlEstadoFormulario=(data)=>{
		if(data.tipoInforme16==TIPOIINFORMESOCIAL){
			
			if(data.estado16>=PENDIENTE_APORTAR || isDSS || isDirector){
				modoConsulta(TIPO_MODO_0, data);
			}else if(data.estado16==INICIADO && (isSSB || isAdmin)){
				modoEdicion(TIPO_MODO_0, data);
			} else{
				modoConsulta(TIPO_MODO_0, data);
			}
		}else if(data.tipoInforme16==TIPOINFORMEINT || data.tipoInforme16==TIPOINFORMESUICIDIO){
			if(data.estado16>=SOLICITADO || isDSS || isSSB || isDirector){
				modoConsulta(TIPO_MODO_1, data);
			} else if(data.estado16==INICIADO && (isPS || isAdmin)){
				modoEdicion(TIPO_MODO_1, data);
			}else {
				modoConsulta(TIPO_MODO_1, data);
				$("#unidadBase16_informes_dialog_table").rup_combo("disable");
				$("#unidadBase16_infInt_dialog_table").rup_combo("disable");

			}
		}
		
	}
	
});